IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Organigrama]') AND type in (N'U'))
BEGIN
CREATE TABLE [dbo].[Organigrama](
	[empresa] [numeric](3, 0) NULL,
	[idOrganigrama] [bigint] IDENTITY(1,1) NOT NULL,
	[clave] [varchar](25) NULL,
	[descripcion] [varchar](200) NULL,
	[Tipo] [varchar](1) NULL,
 CONSTRAINT [PK_Organigrama] PRIMARY KEY CLUSTERED 
(
	[idOrganigrama] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

END

GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Organigrama_Niveles]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
Begin
CREATE TABLE dbo.Organigrama_Niveles
    (
      id BIGINT IDENTITY(1, 1)
                NOT NULL ,
      idOrganigrama BIGINT,
      Clave VARCHAR(50) NOT NULL ,
      Nombre VARCHAR(150) NULL ,
      Nivel INT NOT NULL ,
      Padre VARCHAR(50) ,
      AsignadoA bigint NULL,
      Tipo VARCHAR(1) NULL ,
      CONSTRAINT [PK_Organigrama_Niveles] PRIMARY KEY CLUSTERED
        ( [idOrganigrama] ASC, [Clave] ASC )
        WITH ( PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF,
               IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON,
               ALLOW_PAGE_LOCKS = ON ) ON [PRIMARY]
    )
ON  [PRIMARY]
END

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'AsignadoA'
                        AND sysobjects.name = 'Organigrama_Niveles' ) 
    ALTER TABLE Organigrama_Niveles ADD AsignadoA bigint NULL 

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Tipo'
                        AND sysobjects.name = 'Organigrama' ) 
    ALTER TABLE Organigrama ADD Tipo VARCHAR(1) NULL 

GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Organigrama_Tipo]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
Begin
	CREATE TABLE [dbo].[Organigrama_Tipo] (
		Tipo VARCHAR(2) NOT NULL ,
		Descripcion VARCHAR(100) NOT NULL 
	) ON [PRIMARY]
	ALTER TABLE [dbo].[Organigrama_Tipo] WITH NOCHECK ADD 
		CONSTRAINT [PK_Organigrama_Tipo] PRIMARY KEY  CLUSTERED 
		(
			[Tipo]
		)  ON [PRIMARY] 
	
	INSERT INTO Organigrama_Tipo(Tipo,Descripcion)VALUES('C','DEPARTAMENTOS')
	INSERT INTO Organigrama_Tipo(Tipo,Descripcion)VALUES('T','TABULADORES')
	INSERT INTO Organigrama_Tipo(Tipo,Descripcion)VALUES('S','SUPERVISORES')
	
End

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'[dbo].[EncryptaPassword]')
                    AND xtype IN ( N'FN', N'IF', N'TF' ) ) 
    DROP FUNCTION [dbo].EncryptaPassword

GO

CREATE FUNCTION [dbo].EncryptaPassword
    (
      @password AS VARCHAR(30)
    )
RETURNS VARCHAR(30)
    WITH ENCRYPTION
AS 
    BEGIN

        DECLARE @vClave AS udtName

        SET @vClave = @password

        DECLARE @nCtr AS udtInteger ,
            @nTemp AS udtInteger ,
            @nOffset AS udtInteger ,
            @sPwdTemp AS udtName ,
            @sCodTemp AS udtName

        SET @sPwdTemp = @vClave
        SET @sCodTemp = ''
        SET @nCtr = 1
   
        WHILE @nCtr <= LEN(@sPwdTemp) 
            BEGIN
                SET @nOffset = @nCtr % 3
                SET @nTemp = ASCII(SUBSTRING(@sPwdTemp, @nCtr, 1))
                SET @sCodTemp = @sCodTemp + CHAR(( @nTemp + 10 - @nOffset ))
                SET @nCtr = @nCtr + 1
            END

        RETURN( @sCodTemp )

    END
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenValidaUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenValidaUsuario
GO

CREATE PROCEDURE dbo.ObtenValidaUsuario
    (
      @username udtName ,
      @password udtStringSize512 ,
      @date udtDateTime ,
      @tipo udtName
    )
    WITH ENCRYPTION
AS 
    DECLARE @validUser udtName
    DECLARE @validPass udtName
    DECLARE @userNameFull udtName --= ''
    DECLARE @userId udtLong --= 0
    DECLARE @admin udtName --= ''
    DECLARE @empresa udtInteger
    DECLARE @dateExpire udtDateTime
    SET NOCOUNT ON 
	
    
    IF @tipo = 'NOM' 
        BEGIN
            SET @validUser = CASE WHEN ISNULL(( SELECT  'T'
                                                FROM    dbo.usuarios
                                                WHERE   usuario = @username
                                              ), 'F') = 'T' THEN 'T'
                                  ELSE 'F'
                             END 
            IF @validUser = 'T' 
                BEGIN
                    SET @dateExpire = ( SELECT  expiracion
                                        FROM    dbo.usuarios
                                        WHERE   usuario = @username
                                      )
                    SET @validUser = CASE WHEN @date > ISNULL(@dateExpire,@date) THEN 'F' ELSE @validUser END
                   
                END
            SET @validPass = CASE WHEN @validUser = 'T'
                                       AND ISNULL(( SELECT  'T'
                                                    FROM    dbo.usuarios
                                                    WHERE   password = ( SELECT
                                                              [dbo].EncryptaPassword(@password)
                                                              )
                                                            AND usuario = @username
                                                  ), 'F') = 'T' THEN 'T'
                                  ELSE 'F'
                             END 
            SET @empresa = 0
        END
    ELSE 
        BEGIN
            SET @empresa = ( SELECT empresa
                             FROM   dbo.empleados
                             WHERE  codigo = CAST(@username AS BIGINT)
                                    AND CASE WHEN password_empleado IS NULL
                                                  OR LEN(password_empleado) <= 0
                                             THEN ( SELECT  [dbo].EncryptaPassword(afiliacion)
                                                  )
                                             ELSE password_empleado
                                        END = ( SELECT  [dbo].EncryptaPassword(@password)
                                              )
                           )
		
            IF ISNULL(@empresa, 0) <= 0 
                BEGIN
                    SET @validUser = 'F'
                    SET @validPass = 'F'
                END 
            ELSE 
                BEGIN
                    SET @validUser = 'T'
                    SET @validPass = 'T'
                END 
        END
	
    SELECT  CASE WHEN @validUser = 'F'
                      OR @validPass = 'F'
                 THEN 'EL USUARIO O PASSWORD ES INCORRECTO'
                 WHEN @validUser = 'T'
                      AND @validPass = 'T' THEN 'CORRECTO'
            END AS loginMessage ,
            ISNULL(@empresa, 0)

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenRelojEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenRelojEmpresas
GO

CREATE PROCEDURE dbo.ObtenRelojEmpresas ( @username AS udtName )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debug udtInteger

    DECLARE @cEmpresas udtStringSize255
	
    SET @debug = 0
    SET @whereClauseUsed = 0
    SET @whereClause = ''
    SET @orderByClause = ''
    SET @groupByClause = ''


    SELECT  @cEmpresas = b.empresas
    FROM    perfil_usuarios AS a
            INNER JOIN perfiles AS b ON a.idperfil = b.idperfil
    WHERE   a.usuario = @username
            AND b.sistema = 'RC'
    
    IF LEN(@cEmpresas) > 0 
        BEGIN
            SET @cEmpresas = REPLACE(@cEmpresas, '{', '(')
            SET @cEmpresas = REPLACE(@cEmpresas, '}', ')')
        END 
    ELSE 
        BEGIN
            SET @cEmpresas = '()'
        END 
	
    IF @cEmpresas <> '()' 
        BEGIN
    
            IF @whereClauseUsed = 0 
                BEGIN
	       
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1

                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
	                 
            SET @whereClause = @whereClause + 'empresa in' + @cEmpresas
                 
        END
	
    SET @selectClause = 'SELECT empresa,'
        + 'case when referencia is null or len(rtrim(ltrim(referencia)))<=0 then nombre_empresa else referencia end as nombre_empresa,'
        + 'nombre_empresa,' + 'registro_patronal,' + 'rfc_empresa '
    						
    SET @fromClause = 'FROM    dbo.empresas '
        
    IF @debug = 0 
        BEGIN 
            EXEC(
            @selectClause + @fromClause + @whereClause + @groupByClause + @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END


GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.ObtenOrganigramaNiveles')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.ObtenOrganigramaNiveles
GO

CREATE PROCEDURE dbo.ObtenOrganigramaNiveles
    (
      @idOrganigrama AS BIGINT
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

DECLARE @Niveles AS TABLE (
      idOrganigrama BIGINT,
      Clave VARCHAR(50) NOT NULL ,
      Nombre VARCHAR(150) NULL ,
      Nivel INT NOT NULL ,
      Padre VARCHAR(50) ,
      serial bigint,
      HijoDe BIGINT,
      Codigo INT,
      empresa INT
      )
INSERT INTO @Niveles
        ( idOrganigrama ,
          Clave ,
          Nombre ,
          Nivel ,
          Padre ,
          serial ,
          Codigo ,
          empresa
        )
SELECT a.idOrganigrama,b.Clave,b.Nombre,b.Nivel,b.Padre, ROW_NUMBER() OVER(ORDER BY b.padre,b.Clave asc) AS serial,b.AsignadoA,a.empresa
FROM dbo.Organigrama AS a
INNER JOIN dbo.Organigrama_Niveles AS b ON a.idOrganigrama = b.idOrganigrama
WHERE a.idOrganigrama =@idOrganigrama
ORDER BY b.padre,b.Clave asc

 UPDATE a SET HijoDe=(SELECT serial FROM @Niveles WHERE Clave=a.Padre)
 FROM @Niveles AS a
 
 
 SELECT a.idOrganigrama ,
          a.Clave ,
          a.Nivel ,
          a.Padre ,
          a.serial,
          a.HijoDe,
          a.codigo,
          RTRIM(LTRIM(c.nombre)) + ' ' + RTRIM(LTRIM(c.ap_paterno)) + ' ' + RTRIM(LTRIM(c.ap_materno)) AS NombreEmpleado,
          CASE	WHEN b.Tipo = 'C' THEN RTRIM(e.centro) + ' ' + e.nomdepto
				WHEN b.Tipo = 'S' THEN RTRIM(LTRIM(STR(g.supervisor))) + ' ' + g.nombre 
				WHEN b.Tipo = 'T' THEN RTRIM(LTRIM(STR(f.ocupacion))) + ' ' + f.actividad
		  END AS NombreTipo,
		  i.Descripcion,
		  h.foto,
		  b.Descripcion AS NombreOrganigrama
          --d.foto
          FROM @niveles AS a INNER JOIN dbo.Organigrama AS b ON a.idOrganigrama=b.idOrganigrama
          INNER JOIN dbo.Organigrama_Tipo AS i ON b.Tipo = i.Tipo
          LEFT JOIN dbo.empleados AS c ON a.empresa = c.empresa AND a.codigo = c.codigo
          INNER JOIN dbo.datosemps AS h ON c.empresa = h.empresa AND c.codigo = h.codigo
          INNER JOIN dbo.Llaves AS d ON c.empresa = d.empresa AND c.codigo = d.codigo
          INNER JOIN dbo.supervisores AS g ON d.empresa = g.empresa AND d.supervisor = g.supervisor
          INNER JOIN dbo.tabulador AS f ON d.empresa = f.empresa AND d.ocupacion = f.ocupacion
          INNER JOIN dbo.centros AS e ON d.centro = e.centro AND d.empresa = e.empresa
          ORDER BY a.hijode,a.clave

GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'Organigrama_ListaOrganigramas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Organigrama_ListaOrganigramas
GO
CREATE PROCEDURE dbo.Organigrama_ListaOrganigramas
    (
      @Empresa udtInteger,
      @idOrganigrama udtLong
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        -- Set the debug flag
        SET @debugFlag = 0
        
        -- Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        -- Count all the existing records
        SET @selectClause = ' '
        -- Search criteria: empresa
        IF @Empresa > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'a.empresa = '
                    + LTRIM(RTRIM(STR(@Empresa)))
                 
            END

		IF @idOrganigrama > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'a.idOrganigrama = '
                    + LTRIM(RTRIM(STR(@idOrganigrama)))
                 
            END
		
	    SET @SelectClause = ' SELECT  ' +
							+ ' a.empresa AS empresa,a.idOrganigrama AS idOrganigrama,a.clave AS clave,a.descripcion AS descripcion, a.Tipo '

        SET @FromClause =	' FROM ' +
							' dbo.Organigrama as a ' 
		
		
        SET @OrderByClause = ' '
        
        IF @debugFlag = 1 
            SELECT  @selectClause + @FromClause + @whereClause + @orderByClause
        ELSE 
            EXECUTE (@selectClause + @FromClause + @whereClause + @orderByClause)

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'Organigrama_EmpleadosDisponibles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Organigrama_EmpleadosDisponibles
GO
CREATE PROCEDURE dbo.Organigrama_EmpleadosDisponibles
    (
      @Empresa udtInteger,
      @idOrganigrama udtlong
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        --Set the debug flag
        SET @debugFlag = 0
        
        --Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        --Count all the existing records
        SET @selectClause = ' '
         
        --Search criteria: empresa
        
        IF @Empresa > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'b.empresa = '
                    + LTRIM(RTRIM(STR(@Empresa)))
                 
            END
		
		IF @idOrganigrama > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'a.idOrganigrama = '
                    + LTRIM(RTRIM(STR(@idOrganigrama))) + 
                    ' AND NOT b.codigo IN (SELECT    Organigrama_Niveles.AsignadoA '
											+' FROM      Organigrama_Niveles '
											+' WHERE     Organigrama_Niveles.idOrganigrama = a.idOrganigrama '
													+' AND NOT Organigrama_Niveles.AsignadoA IS NULL )'
            END
            
            IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'b.activo = ''S'' '
                
	    SET @SelectClause = ' SELECT  ' +
							+ ' b.empresa AS empresa ,'
							+ ' b.codigo AS codigo ,'
							+ ' RTRIM(LTRIM(b.nombre)) + '' '' '
							+ ' + RTRIM(LTRIM(b.ap_paterno)) + '' '' '
							+ ' + RTRIM(LTRIM(b.ap_materno)) AS NombreEmpleado ,'
							+ ' CASE WHEN a.Tipo = ''C'' '
								 + ' THEN RTRIM(d.centro) + '' ''  + d.nomdepto '
								 + ' WHEN a.Tipo = ''S'' '
								 + ' THEN RTRIM(LTRIM(STR(f.supervisor))) + '' '' '
									  + ' + f.nombre '
								 + ' WHEN a.Tipo = ''T'' '
								 + ' THEN RTRIM(LTRIM(STR(e.ocupacion))) + '' '' '
									  + ' + e.actividad '
							+ ' END AS NombreTipo '

        SET @FromClause =	' FROM ' +
							' dbo.Organigrama AS a ' 
							+ 'INNER JOIN dbo.empleados AS b ON a.empresa = b.empresa ' 
							+ 'INNER JOIN dbo.Llaves AS c ON b.empresa = c.empresa AND b.codigo = c.codigo ' 
							+ 'INNER JOIN dbo.supervisores AS f ON c.empresa = f.empresa AND c.supervisor = f.supervisor ' 
							+ 'INNER JOIN dbo.tabulador AS e ON c.empresa = e.empresa AND c.ocupacion = e.ocupacion ' 
							+ 'INNER JOIN dbo.centros AS d ON c.centro = d.centro AND c.empresa = d.empresa ' 
		
		
        SET @OrderByClause = ' ORDER BY b.codigo '
        
        IF @debugFlag = 1 
            SELECT  @selectClause + @FromClause + @whereClause + @orderByClause
        ELSE 
            EXECUTE (@selectClause + @FromClause + @whereClause + @orderByClause)

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'Organigrama_MaxNivel'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Organigrama_MaxNivel
GO
CREATE PROCEDURE dbo.Organigrama_MaxNivel
    (
      @idOrganigrama udtlong,
      @IdNivel udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        --Set the debug flag
        SET @debugFlag = 0
        
        --Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        --Count all the existing records
        SET @selectClause = ' '
         
		IF @idOrganigrama > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'a.idOrganigrama = '
                    + LTRIM(RTRIM(STR(@idOrganigrama))) 
            END
        
        IF @IdNivel > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'a.Nivel = '
                    + LTRIM(RTRIM(STR(@IdNivel))) 
            END
            
	    SET @SelectClause = ' SELECT  ' +
							+ ' MAX(ISNULL(a.Nivel,0)) as MaxNivel '

        SET @FromClause =	' FROM ' +
							' dbo.Organigrama_Niveles AS a ' 
		
        SET @OrderByClause = '  '
        
        IF @debugFlag = 1 
            SELECT  @selectClause + @FromClause + @whereClause + @orderByClause
        ELSE 
            EXECUTE (@selectClause + @FromClause + @whereClause + @orderByClause)

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO


IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'Organigrama_MaxClave'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Organigrama_MaxClave
GO
CREATE PROCEDURE dbo.Organigrama_MaxClave
    (
      @idOrganigrama udtlong,
      @IdNivel udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        --Set the debug flag
        SET @debugFlag = 0
        
        --Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        --Count all the existing records
        SET @selectClause = ' '
         
		IF @idOrganigrama > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'a.idOrganigrama = '
                    + LTRIM(RTRIM(STR(@idOrganigrama))) 
            END
        
        IF @IdNivel > 0 
            BEGIN
    
                IF @whereClauseUsed = 0 
                    BEGIN
               
                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1
    
                    END
                ELSE 
                    SET @whereClause = @whereClause + ' AND '
                         
                SET @whereClause = @whereClause + 'a.Nivel = '
                    + LTRIM(RTRIM(STR(@IdNivel))) 
            END
            
	    SET @SelectClause = ' SELECT  ' +
							+ ' MAX(ISNULL(a.clave,0)) as MaxClave '

        SET @FromClause =	' FROM ' +
							' dbo.Organigrama_Niveles AS a ' 
		
        SET @OrderByClause = '  '
        
        IF @debugFlag = 1 
            SELECT  @selectClause + @FromClause + @whereClause + @orderByClause
        ELSE 
            EXECUTE (@selectClause + @FromClause + @whereClause + @orderByClause)

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'Organigrama_Tipos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Organigrama_Tipos
GO
CREATE PROCEDURE dbo.Organigrama_Tipos
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        --Set the debug flag
        SET @debugFlag = 0
        
        --Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        --Count all the existing records
        SET @selectClause = ' '
         
           
	    SET @SelectClause = ' SELECT  ' +
							+ ' Tipo,Descripcion '

        SET @FromClause =	' FROM ' +
							' dbo.Organigrama_Tipo ' 
		
        SET @OrderByClause = '  '
        
        IF @debugFlag = 1 
            SELECT  @selectClause + @FromClause + @whereClause + @orderByClause
        ELSE 
            EXECUTE (@selectClause + @FromClause + @whereClause + @orderByClause)

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'Organigrama_AgregarOrganigrama'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Organigrama_AgregarOrganigrama
GO
CREATE PROCEDURE dbo.Organigrama_AgregarOrganigrama
    (
      @idOrganigrama udtLong,
      @empresa udtInteger, 
      @clave udtName, 
      @descripcion udtName, 
      @Tipo udtName
          )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        SET @debugFlag = 0
        
        -- Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        -- Count all the existing records
        SET @selectClause = ' '
        
        IF @idOrganigrama <= 0 
        BEGIN
			INSERT INTO dbo.Organigrama
					( empresa, clave, descripcion, Tipo )
			VALUES  ( @empresa, @clave, @descripcion, @Tipo
					  )
		END
		ELSE BEGIN
			UPDATE dbo.Organigrama SET clave = @clave, Tipo = @Tipo, descripcion = @descripcion
			WHERE idOrganigrama = @idOrganigrama
					AND empresa = @empresa
		END 

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'Organigrama_AgregaElemento'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.Organigrama_AgregaElemento
GO


CREATE PROCEDURE dbo.Organigrama_AgregaElemento
    (
      @idOrganigrama udtLong,
      @Clave udtStringSize128,
      @Nivel udtLong,
      @Padre udtStringSize128,
      @AsignadoA udtLong
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        SET @debugFlag = 0
        
        -- Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        -- Count all the existing records
        SET @selectClause = ' '
        -- Search criteria: empresa
        INSERT INTO dbo.Organigrama_Niveles
                ( idOrganigrama ,
                  Clave ,
                  Nivel ,
                  Padre ,
                  AsignadoA
                )
        VALUES  ( @idOrganigrama ,
                  @Clave ,
                  @Nivel ,
                  @Padre ,
                  @AsignadoA
                )

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.Organigrama_EliminaElemento')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.Organigrama_EliminaElemento
GO


CREATE PROCEDURE dbo.Organigrama_EliminaElemento
    (
      @idOrganigrama udtLong,
      @Clave udtStringSize128
          )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @FromClause AS NVARCHAR(4000)
    DECLARE @OrderByClause AS NVARCHAR(4000)
    DECLARE @GroupByClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean

    SET @selectClause = ''
    SET @FromClause = ''
    SET @OrderByClause = ''
    SET @GroupByClause = ''
    SET @whereClause = ''
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
    
        SET @debugFlag = 0
        
        -- Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''
        
        -- Count all the existing records
        SET @selectClause = ' '
        
        DELETE dbo.Organigrama_Niveles 
        WHERE idOrganigrama = @idOrganigrama
				AND Clave = @Clave

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION            
GO
